$!      Produces a COM file, NUKE_STOP.COM, to do IMAGE_ABORTs on all Ingres
$!      front-ends, and several COM files, IMG_ABORT.node-name, (one per node)
$!      to STOP/ID all Ingres front-ends and back-ends (if the image_abort
$!      is unsuccessful)
$!
$!      WARNING:  THIS JOB IS HARMLESS, but the
$!                files it PRODUCES are NUKErs  !!!
$!
$!      Written by: Rod Stover, Senior Systems Analyst
$!                  El Paso County Information Services
$!                  Colorado Springs, CO 80919
$!                  30-Jul-1991
$!
$!      NOTE: XXX users are skipped     !!! you set users to skip !!!
$!            only INGRES jobs (with ING_BACK*) jobs acknowledged
$!
$       SHOW USER/FULL/OUTPUT=NUKE_PREP.DAT
$!
$!      Create one file for each NODE on your system
$!      !!! You set node names as needed in     !!!
$!      !!! place on node1, node2, node3, node4 !!!
$!
$       OPEN/WRITE NODE1    IMG_ABORT.NODE1     !!! you set node names !!!
$       OPEN/WRITE NODE2    IMG_ABORT.NODE2
$       OPEN/WRITE NODE3    IMG_ABORT.NODE3
$       OPEN/WRITE NODE4    IMG_ABORT.NODE4
$       OPEN/WRITE S        NUKE_STOP.COM
$!
$       WRITE NODE1 "$ bel[0,7] == 7"           !!! you set node names !!!
$       WRITE NODE1 "$ esc[0,7] == 27"
$       WRITE NODE1 "$ clrstr:=='esc'[2J'esc'[1;1H"
$       WRITE NODE1 "$ PUT CLRSTR,BEL"
$       WRITE NODE1 "$ TYPE SYS$INPUT"
$       WRITE NODE1 "  WARNING:"
$       WRITE NODE1 "  This job does an IMAGE_ABORT on Ingres FRONT-ends"
$       WRITE NODE1 "$ WAIT 00:00:02
$!
$       WRITE NODE2 "$ bel[0,7] == 7"
$       WRITE NODE2 "$ esc[0,7] == 27"
$       WRITE NODE2 "$ clrstr:=='esc'[2J'esc'[1;1H"
$       WRITE NODE2 "$ PUT CLRSTR,BEL"
$       WRITE NODE2 "$ TYPE SYS$INPUT"
$       WRITE NODE2 "  WARNING:"
$       WRITE NODE2 "  This job does an IMAGE_ABORT on Ingres FRONT-ends"
$       WRITE NODE2 "$ WAIT 00:00:02
$!
$       WRITE NODE3 "$ bel[0,7] == 7"
$       WRITE NODE3 "$ esc[0,7] == 27"
$       WRITE NODE3 "$ clrstr:=='esc'[2J'esc'[1;1H"
$       WRITE NODE3 "$ PUT CLRSTR,BEL"
$       WRITE NODE3 "$ TYPE SYS$INPUT"
$       WRITE NODE3 "  WARNING:"
$       WRITE NODE3 "  This job does an IMAGE_ABORT on Ingres FRONT-ends"
$       WRITE NODE3 "$ WAIT 00:00:02
$!
$       WRITE NODE4 "$ bel[0,7] == 7"
$       WRITE NODE4 "$ esc[0,7] == 27"
$       WRITE NODE4 "$ clrstr:=='esc'[2J'esc'[1;1H"
$       WRITE NODE4 "$ PUT CLRSTR,BEL"
$       WRITE NODE4 "$ TYPE SYS$INPUT"
$       WRITE NODE4 "  WARNING:"
$       WRITE NODE4 "  This job does an IMAGE_ABORT on Ingres FRONT-ends"
$       WRITE NODE4 "$ WAIT 00:00:02
$!
$       WRITE S "$ bel[0,7] == 7"
$       WRITE S "$ esc[0,7] == 27"
$       WRITE S "$ clrstr:=='esc'[2J'esc'[1;1H"
$       WRITE S "$ PUT CLRSTR,BEL"
$       WRITE S "$ TYPE SYS$INPUT"
$       WRITE S "  WARNING:"
$       WRITE S "  This job does a STOP/ID= on Ingres jobs; "
$       WRITE S "       FRONT-ends and BACK-ends"
$       WRITE S "$ WAIT 00:00:02
$!
$       OPEN/READ X NUKE_PREP.DAT
$!
$ READFILE:
$       read/end_of_file=CLOSE X LIST_REC
$       LEN = f$len(LIST_REC)
$       X1 = F$LOCATE("ING_BACK",list_rec)
$       if X1 .ge. LEN then GOTO READFILE
$!
$ ING_FOUND:
$       THIS_USER=F$EXTRACT(1,12,LIST_REC)
$       PREFX = F$EXTRACT(0,3,THIS_USER)
$       IF PREFX .EQS. "XXX"            !!! you set users to skip !!!
$       THEN
$           PUT THIS_USER," IGNORED"
$           WAIT 00:00:01
$           GOTO READFILE
$       ENDIF
$       THIS_NODE=F$EDIT(F$EXTRACT(13,9,LIST_REC),"TRIM")
$       X1 = F$LOCATE("(subprocess of",list_rec)
$       FRONT_PID=f$extract(x1+15,8,list_rec)
$       BACK_PID=F$EXTRACT(x1-10,8,list_rec)
$       WRITE S "$ PUT CLRSTR"
$       WRITE S "$ SHOW USER/FULL/NODE=''THIS_NODE' ''THIS_USER'"
$       WRITE S "$ PUT "" """
$       WRITE S "$ INQUIRE X ""BACKEND:  STOP/ID=''back_pid' ?"""
$       WRITE S "$ IF X THEN $ STOP/ID=''back_pid'"
$       WRITE S "$ PUT "" """
$       WRITE S "$ INQUIRE X ""FRONTEND:  STOP/ID=''front_pid' ?"""
$       WRITE S "$ IF X THEN $ STOP/ID=''front_pid'"
$!
$       WRITE 'THIS_NODE' "$ PUT CLRSTR"
$       WRITE 'THIS_NODE' "$ SHOW USER/FULL/NODE=''THIS_NODE' ''THIS_USER'"
$       WRITE 'THIS_NODE' "$ PUT "" """
$       WRITE 'THIS_NODE' "$ INQUIRE X ""IMAGE_ABORT FRONTEND ''front_pid' ?"""
$       WRITE 'THIS_NODE' "$ IF X THEN $ RUN SYSUTI:IMG_ABORT"
$       WRITE 'THIS_NODE' front_pid
$       WRITE 'THIS_NODE' "$ IF X THEN $ WAIT 00:00:02"
$       GOTO READFILE
$!
$ CLOSE:
$       WRITE S "$ EXIT"
$       WRITE NODE1 "$ EXIT"     !!! you set node names !!!
$       WRITE NODE2 "$ EXIT"
$       WRITE NODE3 "$ EXIT"
$       WRITE NODE4 "$ EXIT"
$!
$       CLOSE X
$       CLOSE S
$       CLOSE NODE1     !!! you set node names !!!
$       CLOSE NODE2
$       CLOSE NODE3
$       CLOSE NODE4
$!
$       DIR/SIZE/DATE/VERS=1 IMG_ABORT.*
$       DIR/SIZE/DATE/VERS=1 NUKE_STOP.COM
$       DELETE/NOLOG/NOCONFIRM NUKE_PREP.DAT;*
$!
$       EXIT
